package core;


/**
 * Imports
 */


/**
 * Area
 * @author Varkalas D`Lonovan
 */
public class Area {
	/**
	 * Class Variables
	 */
	private String name;
	private String above;
	private String below;
	private String left;
	private String right;
	private int mask[][];
	private String spawnPoints[][];
	private String entrancePoints[][];
	//private List creatures;    // GameEntity's
	//private List entrances[];  // String's


	/**
	 * Constructor
	 */
	public Area() {
		name = "";
		above = "";
		below = "";
		left = "";
		right = "";
		mask = new int[20][15];
		spawnPoints = new String[20][15];
		entrancePoints = new String[20][15];
		for (int index1 = 0; index1 < 20; index1++) {
			for (int index2 = 0; index2 < 15; index2++) {
				spawnPoints[index1][index2] = "";
				entrancePoints[index1][index2] = "";
			}
		}
	}


	/**
	 * getName
	 * @return Returns the name of the area.
	 */
	public String getName() {
		return name;
	}


	/**
	 * setName
	 * @param name The name of the area.
	 */
	public void setName(String name) {
		this.name = name;
	}


	/**
	 * @return Returns the above.
	 */
	public String getAbove() {
		return above;
	}


	/**
	 * @param above The above to set.
	 */
	public void setAbove(String above) {
		this.above = above;
	}


	/**
	 * @return Returns the below.
	 */
	public String getBelow() {
		return below;
	}


	/**
	 * @param below The below to set.
	 */
	public void setBelow(String below) {
		this.below = below;
	}


	/**
	 * @return Returns the left.
	 */
	public String getLeft() {
		return left;
	}


	/**
	 * @param left The left to set.
	 */
	public void setLeft(String left) {
		this.left = left;
	}


	/**
	 * @return Returns the right.
	 */
	public String getRight() {
		return right;
	}


	/**
	 * @param right The right to set.
	 */
	public void setRight(String right) {
		this.right = right;
	}


	/**
	 * @return Returns the mask.
	 */
	public int[][] getMask() {
		return mask;
	}


	/**
	 * Sets the mask.
	 * @param value The value to be placed.
	 * @param x The x coordinate. (0 to 19)
	 * @param y The y coordinate. (0 to 14)
	 */
	public void setMask(int value, int x, int y) {
		mask[x][y] = value;
	}


	/**
	 * @return Returns the spawnPoints.
	 */
	public String[][] getSpawnPoints() {
		return spawnPoints;
	}


	/**
	 * @param name The name of the creature that spawns here.
	 * @param x The x location of the spawn point.
	 * @param y The y location of the spawn point.
	 */
	public void setSpawnPoint(String name, int x, int y) {
		spawnPoints[x][y] = name;
	}


	/**
	 * @return Returns the entrance points.
	 */
	public String[][] getEntrancePoints() {
		return entrancePoints;
	}


	/**
	 * @param name The name of the area entrance that's here.
	 * @param x The x location of the spawn point.
	 * @param y The y location of the spawn point.
	 */
	public void setEntrancePoint(String name, int x, int y) {
		entrancePoints[x][y] = name;
	}
}