package core;


/**
 * Imports
 */
import java.util.LinkedList;


/**
 * Inventory
 * @author Varkalas D`Lonovan
 */
public class Equipment {
	/**
	 * Class Variables
	 */
	private LinkedList inventory;
    private Item head;
    private Item neck;
    private Item chest;
    private Item shoulders;
    private Item arms;
    private Item wrists;
    private Item hands;
    private Item waist;
    private Item legs;
    private Item feet;
    private Item lhfinger;
    private Item rhfinger;
    private Item lhweapon;
    private Item rhweapon;


	/**
	 * Constructor
	 */
	public Equipment() {
		inventory = new LinkedList();
	}


	/**
	 * getInventory
	 * @return Returns the inventory.
	 */
	public LinkedList getInventory() {
		return inventory;
	}


	/**
	 * addToItemsCarrying
	 * @param anItem The item to be added to the inventory.
	 */
	public void addToInventory(Item anItem) {
		inventory.add(anItem);
	}


	/**
	 * removeFromInventory
	 * @param anItem The item to be removed from the inventory.
	 */
	public void removeFromInventory(Item anItem) {
		inventory.remove(anItem);
	}


	/**
	 * addToWornEquipment
	 * @param bodyLocation The location that the item will be placed on.
	 * @param anItem The item itself.
	 */
	public void addToWornEquipment(Item anItem) {
		if (anItem.getBodyLocation().equals("HEAD")) {
			head = anItem;
		} else if (anItem.getBodyLocation().equals("NECK")) {
			neck = anItem;
		} else if (anItem.getBodyLocation().equals("CHEST")) {
			chest = anItem;
		} else if (anItem.getBodyLocation().equals("SHOULDERS")) {
			shoulders = anItem;
		} else if (anItem.getBodyLocation().equals("ARMS")) {
			arms = anItem;
		} else if (anItem.getBodyLocation().equals("WRISTS")) {
			wrists = anItem;
		} else if (anItem.getBodyLocation().equals("HANDS")) {
			hands = anItem;
		} else if (anItem.getBodyLocation().equals("WAIST")) {
			waist = anItem;
		} else if (anItem.getBodyLocation().equals("LEGS")) {
			legs = anItem;
		} else if (anItem.getBodyLocation().equals("FEET")) {
			feet = anItem;
		} else if (anItem.getBodyLocation().equals("LHFINGER")) {
			lhfinger = anItem;
		} else if (anItem.getBodyLocation().equals("RHFINGER")) {
			rhfinger = anItem;
		} else if (anItem.getBodyLocation().equals("LHWEAPON")) {
			lhweapon = anItem;
		} else if (anItem.getBodyLocation().equals("RHWEAPON")) {
			rhweapon = anItem;
		}
	}


	/**
     * getArms
     * @return Returns the item on the arms.
     */
	public Item getArms() {
		return arms;
	}


	/**
	 * getChest
	 * @return Returns the item on the chest.
	 */
	public Item getChest() {
		return chest;
	}


	/**
	 * getFeet
	 * @return Returns the items on the feet.
	 */
	public Item getFeet() {
		return feet;
	}


	/**
	 * getHands
	 * @return Returns the item on the hands.
	 */
	public Item getHands() {
		return hands;
	}


	/**
	 * getHead
	 * @return Gets the item on the head.
	 */
	public Item getHead() {
		return head;
	}


	/**
	 * getLegs
	 * @return Returns the item on the legs.
	 */
	public Item getLegs() {
		return legs;
	}


	/**
	 * getLhfinger
	 * @return Returns the item on the left hand finger.
	 */
	public Item getLhfinger() {
		return lhfinger;
	}


	/**
	 * getLhweapon
	 * @return Returns the item on the left hand weapon.
	 */
	public Item getLhweapon() {
		return lhweapon;
	}


	/**
	 * getNeck
	 * @return Returns the item on the neck.
	 */
	public Item getNeck() {
		return neck;
	}


	/**
	 * getRhfinger
	 * @return Returns the item on the right hand finger.
	 */
	public Item getRhfinger() {
		return rhfinger;
	}


	/**
	 * getRhweapon
	 * @return Returns the item on the right hand weapon.
	 */
	public Item getRhweapon() {
		return rhweapon;
	}


	/**
	 * getShoulders
	 * @return Returns the item on the shoulders.
	 */
	public Item getShoulders() {
		return shoulders;
	}


	/**
	 * getWaist
	 * @return Returns the item on the waist.
	 */
	public Item getWaist() {
		return waist;
	}


	/**
	 * getWrists
	 * @return Returns the item on the wrists.
	 */
	public Item getWrists() {
		return wrists;
	}
}