package core;


/**
 * Imports
 */
import graphics.Renderer;


/**
 * The Game Class
 * @author Varkalas D`Lonovan
 */
public class Game {
	/**
	 * Class Variables
	 */
	private World world;
	private GameEntity character;
	private Renderer renderer;


	/**
     * Constructor
     */
    public Game() {
    	world = new World();
    	System.out.print("Loading Player Instance... ");
    	character = new GameEntity(world);
    	System.out.println("DONE");
    	System.out.print("Loading Graphics.. ");
    	renderer = new Renderer(this);
    	System.out.println("DONE");
    }


    /**
     * The main method that creates a new game and starts it.
     * @param args Arguments taken in from the command-line.
     */
    public static void main(String[] args) {
        Game newGame = new Game();
        newGame.getRenderer().setEngineRunning(true);
        newGame.getRenderer().gameLoop();
    }


    /**
     * @return Returns the player's character.
     */
    public GameEntity getCharacter() {
    	return character;
    }


    /**
     * @return Returns the world.
     */
    public World getWorld() {
    	return world;
    }


    /**
     * @return Returns the graphics renderer.
     */
    public Renderer getRenderer() {
    	return renderer;
    }
}