package core;


/**
 * Imports
 */
import java.io.Serializable;


/**
 * Item
 * @author Varkalas D`Lonovan
 */
public class Item implements Serializable {
	/**
	 * Class Variables
	 */
	private static final long serialVersionUID = -1410719340435566150L;
    private String name;
    private String bodyLocation;
    private int damageRating;
    private int attackSpeed;
    private int armorRating;
    private Spell clickableSpell;
    private Spell weaponEffect;


    /**
     * Constructor
     */
    public Item() {
    	clickableSpell = null;
    	weaponEffect = null;
    }


    /**
     * getName
     * @return Returns the name of the item.
     */
    public String getName() {
    	return name;
    }


    /**
     * setName
     * @param aName The name to be given to the item.
     */
    public void setName(String aName) {
    	name = aName;
    }


    /**
     * getBodyLocation
     * @return Returns the location on the body the item belongs.
     */
    public String getBodyLocation() {
    	return bodyLocation;
    }


    /**
     * setBodyLocation
     * @param aBodyLocation Set the location of the item on the body.
     */
    public void setBodyLocation(String aBodyLocation) {
    	bodyLocation = aBodyLocation;
    }


    /**
     * getDamageRating
     * @return Returns the damage rating of the item.
     */
    public int getDamageRating() {
    	return damageRating;
    }


    /**
     * setDamageRating
     * @param aDamageRating The damage rating of the item.
     */
    public void setDamageRating(int aDamageRating) {
    	damageRating = aDamageRating;
    }


    /**
     * getAttackSpeed
     * @return Returns the attack speed of the item.
     */
    public int getAttackSpeed() {
    	return attackSpeed;
    }


    /**
     * setAttackSpeed
     * @param anAttackSpeed The attack speed of the item.
     */
    public void setAttackSpeed(int anAttackSpeed) {
    	attackSpeed = anAttackSpeed;
    }


    /**
     * getArmorRating
     * @return Returns the defense rating of the item.
     */
    public int getArmorRating() {
    	return armorRating;
    }


    /**
     * setArmorRating
     * @param anArmorRating The armor rating of the item.
     */
    public void setArmorRating(int anArmorRating) {
    	armorRating = anArmorRating;
    }


	/**
	 * @return Returns the clickableSpell.
	 */
	public Spell getClickableSpell() {
		return clickableSpell;
	}


	/**
	 * @return Returns the weaponEffect.
	 */
	public Spell getWeaponEffect() {
		return weaponEffect;
	}


	/**
	 * @param clickableSpell The clickableSpell to set.
	 */
	public void setClickableSpell(Spell clickableSpell) {
		this.clickableSpell = clickableSpell;
	}


	/**
	 * @param weaponEffect The weaponEffect to set.
	 */
	public void setWeaponEffect(Spell weaponEffect) {
		this.weaponEffect = weaponEffect;
	}
}