package core;


/**
 * Imports
 */
import java.io.Serializable;


/**
 * Statistics
 * @author Varkalas D`Lonovan
 */
public class Skills implements Serializable {
	/**
	 * Class Variables
	 */
	private static final long serialVersionUID = 588651190255983822L;
	private float physicalStrength;
	private float mentalStrength;
	private float physicalEndurance;
	private float mentalEndurance;
	private float accuracy;
	private float attackRate;
	private float castingRate;
	private float evasion;
	private float parrying;
	private float blocking;
	private float multipleOpponents;
	private float disarmTraps;
	private float lockpicking;
	private float thieving;


	/**
	 * Constructor
	 */
	public Skills() {
		physicalStrength = 0;
		mentalStrength = 0;
		physicalEndurance = 0;
		mentalEndurance = 0;
		accuracy = 0;
		attackRate = 0;
		castingRate = 0;
		evasion = 0;
		parrying = 0;
		blocking = 0;
		multipleOpponents = 0;
		disarmTraps = 0;
		lockpicking = 0;
		thieving = 0;
	}


	/**
	 * raiseSkill
	 * @param skillName The name of the skill that's being learned.
	 */
	public void raiseSkill(String skillName) {
		float currentSkillLevel = 0.0f;

		// find which skill we're using
		if (skillName.equals("physicalStrength")) {
			currentSkillLevel = physicalStrength;
		} else if (skillName.equals("mentalStrength")) {
			currentSkillLevel = mentalStrength;
		} else if (skillName.equals("physicalEndurance")) {
			currentSkillLevel = physicalEndurance;
		} else if (skillName.equals("mentalEndurance")) {
			currentSkillLevel = mentalEndurance;
		} else if (skillName.equals("accuracy")) {
			currentSkillLevel = accuracy;
		} else if (skillName.equals("attackRate")) {
			currentSkillLevel = attackRate;
		} else if (skillName.equals("castingRate")) {
			currentSkillLevel = castingRate;
		} else if (skillName.equals("evasion")) {
			currentSkillLevel = evasion;
		} else if (skillName.equals("parrying")) {
			currentSkillLevel = parrying;
		} else if (skillName.equals("blocking")) {
			currentSkillLevel = blocking;
		} else if (skillName.equals("multipleOpponents")) {
			currentSkillLevel = multipleOpponents;
		} else if (skillName.equals("disarmTraps")) {
			currentSkillLevel = disarmTraps;
		} else if (skillName.equals("lockpicking")) {
			currentSkillLevel = lockpicking;
		} else if (skillName.equals("thieving")) {
			currentSkillLevel = thieving;
		}

		// calculations
		if (currentSkillLevel >= 0 && currentSkillLevel < 5) {
			currentSkillLevel += .04;
		} else if (currentSkillLevel >= 5 && currentSkillLevel < 10) {
			currentSkillLevel += .03;
		} else if (currentSkillLevel >= 10 && currentSkillLevel < 20) {
			currentSkillLevel += .01;
		} else if (currentSkillLevel >= 20 && currentSkillLevel < 30) {
			currentSkillLevel += .0075;
		} else {
			currentSkillLevel += .005;
		}

		// raise that skill
		setSkill(skillName, currentSkillLevel);
	}


	/**
	 * setSkill
	 * @param skillName The name of the skill.
	 * @param skillLevel The level of the skill.
	 */
	public void setSkill(String skillName, float skillLevel) {
		if (skillName.equals("physicalStrength")) {
			physicalStrength = skillLevel;
		} else if (skillName.equals("mentalStrength")) {
			mentalStrength = skillLevel;
		} else if (skillName.equals("physicalEndurance")) {
			physicalEndurance = skillLevel;
		} else if (skillName.equals("mentalEndurance")) {
			mentalEndurance = skillLevel;
		} else if (skillName.equals("accuracy")) {
			accuracy = skillLevel;
		} else if (skillName.equals("attackRate")) {
			attackRate = skillLevel;
		} else if (skillName.equals("castingRate")) {
			castingRate = skillLevel;
		} else if (skillName.equals("evasion")) {
			evasion = skillLevel;
		} else if (skillName.equals("parrying")) {
			parrying = skillLevel;
		} else if (skillName.equals("blocking")) {
			blocking = skillLevel;
		} else if (skillName.equals("multipleOpponents")) {
			multipleOpponents = skillLevel;
		} else if (skillName.equals("disarmTraps")) {
			disarmTraps = skillLevel;
		} else if (skillName.equals("lockpicking")) {
			lockpicking = skillLevel;
		} else if (skillName.equals("thieving")) {
			thieving = skillLevel;
		}
	}


	/**
	 * @return Returns the attackRate.
	 */
	public float getAttackRate() {
		return attackRate;
	}


	/**
	 * @return Returns the blocking.
	 */
	public float getBlocking() {
		return blocking;
	}


	/**
	 * @return Returns the castingRate.
	 */
	public float getCastingRate() {
		return castingRate;
	}


	/**
	 * @return Returns the disarmTraps.
	 */
	public float getDisarmTraps() {
		return disarmTraps;
	}


	/**
	 * @return Returns the evasion.
	 */
	public float getEvasion() {
		return evasion;
	}


	/**
	 * @return Returns the lockpicking.
	 */
	public float getLockpicking() {
		return lockpicking;
	}


	/**
	 * @return Returns the mentalEndurance.
	 */
	public float getMentalEndurance() {
		return mentalEndurance;
	}


	/**
	 * @return Returns the mentalStrength.
	 */
	public float getMentalStrength() {
		return mentalStrength;
	}


	/**
	 * @return Returns the multipleOpponents.
	 */
	public float getMultipleOpponents() {
		return multipleOpponents;
	}


	/**
	 * @return Returns the parrying.
	 */
	public float getParrying() {
		return parrying;
	}


	/**
	 * @return Returns the physicalEndurance.
	 */
	public float getPhysicalEndurance() {
		return physicalEndurance;
	}


	/**
	 * @return Returns the physicalStrength.
	 */
	public float getPhysicalStrength() {
		return physicalStrength;
	}


	/**
	 * @return Returns the thieving.
	 */
	public float getThieving() {
		return thieving;
	}


	/**
	 * @return Returns the accuracy.
	 */
	public float getAccuracy() {
		return accuracy;
	}
}