package graphics;


/**
 * Imports
 */
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;

import core.GameEntity;


/**
 * CharacterCreationGUI
 * @author Varkalas D`Lonovan
 */
public class CharacterCreationGUI extends GUI {
	/**
	 * Class Variables
	 */
	private Renderer renderer;
	private Image background;
	private BufferedImage currentProfession;
	private int currentSelection;
	private int professionSelection;
	private String[] professions = {"Warrior",
			                        "Paladin",
			                        "Ranger",
			                        "Cleric",
			                        "Druid",
			                        "Thief",
			                        "Sorcerer",
			                        "Wizard"};
	private String name;
	private String profession;


	/**
	 * Constructor
	 */
	public CharacterCreationGUI(Renderer renderer) {
		this.renderer = renderer;
		background = (new ImageIcon("Images/Backgrounds/CharacterCreation.gif")).getImage();
		currentSelection = 0;
		professionSelection = -1;
		name = "";
		profession = "";
	}


    /**
     * mouseMoved
     * @param mouseEvent The event the mouse goes through.
     */
    public void mouseMoved(MouseEvent mouseEvent) {
    }


    /**
     * mouseReleased
     * @param mouseEvent The event the mouse goes through.
     */
    public void mouseReleased(MouseEvent mouseEvent) {
    	// professions
    	if (mouseEvent.getX() >= 60 && mouseEvent.getX() < 180) {
            if (mouseEvent.getY() >= 145 && mouseEvent.getY() < 165) {
            	professionSelection = 0;
            	profession = professions[professionSelection];
            	try {
            		currentProfession = ImageIO.read(new File("Images/Sprites/Professions/" + professions[professionSelection] + ".bmp"));
            	} catch (IOException exception) {
            		System.err.println("[CharacterCreationGUI.java]  Could not read in the image.");
            	}
            } else if (mouseEvent.getY() >= 185 && mouseEvent.getY() < 205) {
            	professionSelection = 1;
            	profession = professions[professionSelection];
            	try {
            		currentProfession = ImageIO.read(new File("Images/Sprites/Professions/" + professions[professionSelection] + ".bmp"));
            	} catch (IOException exception) {
            		System.err.println("[CharacterCreationGUI.java]  Could not read in the image.");
            	}
            } else if (mouseEvent.getY() >= 225 && mouseEvent.getY() < 245) {
            	professionSelection = 2;
            	profession = professions[professionSelection];
            	try {
            		currentProfession = ImageIO.read(new File("Images/Sprites/Professions/" + professions[professionSelection] + ".bmp"));
            	} catch (IOException exception) {
            		System.err.println("[CharacterCreationGUI.java]  Could not read in the image.");
            	}
            } else if (mouseEvent.getY() >= 265 && mouseEvent.getY() < 285) {
            	professionSelection = 3;
            	profession = professions[professionSelection];
            	try {
            		currentProfession = ImageIO.read(new File("Images/Sprites/Professions/" + professions[professionSelection] + ".bmp"));
            	} catch (IOException exception) {
            		System.err.println("[CharacterCreationGUI.java]  Could not read in the image.");
            	}
            } else if (mouseEvent.getY() >= 305 && mouseEvent.getY() < 325) {
            	professionSelection = 4;
            	profession = professions[professionSelection];
            	try {
            		currentProfession = ImageIO.read(new File("Images/Sprites/Professions/" + professions[professionSelection] + ".bmp"));
            	} catch (IOException exception) {
            		System.err.println("[CharacterCreationGUI.java]  Could not read in the image.");
            	}
            } else if (mouseEvent.getY() >= 345 && mouseEvent.getY() < 365) {
            	professionSelection = 5;
            	profession = professions[professionSelection];
            	try {
            		currentProfession = ImageIO.read(new File("Images/Sprites/Professions/" + professions[professionSelection] + ".bmp"));
            	} catch (IOException exception) {
            		System.err.println("[CharacterCreationGUI.java]  Could not read in the image.");
            	}
            } else if (mouseEvent.getY() >= 385 && mouseEvent.getY() < 405) {
            	professionSelection = 6;
            	profession = professions[professionSelection];
            	try {
            		currentProfession = ImageIO.read(new File("Images/Sprites/Professions/" + professions[professionSelection] + ".bmp"));
            	} catch (IOException exception) {
            		System.err.println("[CharacterCreationGUI.java]  Could not read in the image.");
            	}
            } else if (mouseEvent.getY() >= 425 && mouseEvent.getY() < 445) {
            	professionSelection = 7;
            	profession = professions[professionSelection];
            	try {
            		currentProfession = ImageIO.read(new File("Images/Sprites/Professions/" + professions[professionSelection] + ".bmp"));
            	} catch (IOException exception) {
            		System.err.println("[CharacterCreationGUI.java]  Could not read in the image.");
            	}
            }
            currentSelection = 0;
        }

    	// name
    	if (mouseEvent.getX() >= 120 && mouseEvent.getX() < 500) {
    		if (mouseEvent.getY() >= 90 && mouseEvent.getY() < 120) {
    			currentSelection = 1;
    		}
    	}

    	// enter world
    	if (mouseEvent.getX() >= 400 && mouseEvent.getX() <= 570) {
    		if (mouseEvent.getY() >= 375 && mouseEvent.getY() <= 400) {
    			currentSelection = 2;
    			// setup a new character
    			if (!name.equals("") && !profession.equals("")) {
    				// generate the new character
    				renderer.getGame().getCharacter().newPlayer(name, profession, GameEntity.PLAYER, 2);

    				// put this character into the world
    				renderer.getGame().getWorld().setPlayer(renderer.getGame().getCharacter());
    				renderer.switchWindow(Renderer.WORLD_WINDOW);

    			// missing a name
    			} else if (name.equals("")) {
    				JOptionPane.showConfirmDialog(renderer,
    						                      "Please enter a name for your character.",
    						                      "Error",
    						                      JOptionPane.DEFAULT_OPTION,
    						                      JOptionPane.ERROR_MESSAGE);
    				currentSelection = 1;

    			// missing a profession
    			} else if (profession.equals("")) {
    				JOptionPane.showConfirmDialog(renderer,
		                      "Please select a profession for your character.",
		                      "Error",
		                      JOptionPane.DEFAULT_OPTION,
		                      JOptionPane.ERROR_MESSAGE);
    				currentSelection = 0;
    			}
    		}
    	}
    }


	/**
	 * keyPressed
     * @param keyEvent The key pressed.
	 */
	public void keyPressed(KeyEvent keyEvent) {
		if (currentSelection == 1) {
			if (keyEvent.getKeyCode() == KeyEvent.VK_BACK_SPACE) {
				if (name.length() > 0) {
					name = name.substring(0, name.length() - 1);
				}
			} else if (name.length() <= 20 && keyEvent.getKeyCode() != KeyEvent.VK_BACK_SPACE
					                       && keyEvent.getKeyCode() != KeyEvent.VK_TAB
					                       && keyEvent.getKeyChar() != KeyEvent.VK_SPACE) {
				name += keyEvent.getKeyChar();
			}
		}
		if (keyEvent.getKeyCode() == KeyEvent.VK_ESCAPE) {
			renderer.setGameRunning(false);
		}
	}


	/**
     * renderer
     * @param graphics The graphics display.
     */
    public void render(Graphics2D graphics) {
    	// member variables
    	int increment = 40;

    	// draw the background
    	graphics.drawImage(background, 0, 0, null);

    	// draw the title
    	graphics.setFont(graphics.getFont().deriveFont(48.0f));
    	graphics.setColor(Color.CYAN);
    	graphics.drawString("Character Creation", 160, 60);

    	// draw the professions
    	graphics.setFont(graphics.getFont().deriveFont(32.0f));
    	for (int index = 0; index < professions.length; index++) {
    		if (professionSelection == index) {
    			graphics.setColor(Color.YELLOW);
    			graphics.drawImage((Image) currentProfession, 18, 140 + (increment * index), null);
    		} else {
    			graphics.setColor(Color.BLACK);
    		}
    		graphics.drawString(professions[index], 60, 165 + (increment * index));
    	}

    	// name
    	if (currentSelection == 1) {
    		graphics.setColor(Color.YELLOW);
    	} else {
    		graphics.setColor(Color.WHITE);
    	}
    	graphics.drawString("Name:", 120, 120);
    	graphics.drawRect(200, 90, 300, 30);
    	graphics.setFont(graphics.getFont().deriveFont(28.0f));
    	graphics.setColor(Color.YELLOW);
    	graphics.drawString(name, 205, 115);

    	// information about professions
    	if (professionSelection == 0) {
    		graphics.setFont(graphics.getFont().deriveFont(24.0f));
        	graphics.setColor(Color.GREEN);
    		graphics.drawString("The warrior is a strong melee combatant", 180, 164);
    		graphics.drawString("who blah blah blah blah blah blah blah ", 180, 194);
    	}

    	// enter the world
    	graphics.setFont(graphics.getFont().deriveFont(42.0f));
    	if (currentSelection == 2) {
    		graphics.setColor(Color.YELLOW);
    	} else {
    		graphics.setColor(Color.BLACK);
    	}
    	graphics.drawString("Enter World", 400, 400);
    }
}