package graphics;


/**
 * Imports
 */
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;


/**
 * TitleGUI
 */
public class ContinueCharacterGUI extends GUI {
	/**
	 * Class Variables
	 */
	private Renderer renderer;
	private Image background;
	private Image characterSprite;
	private int currentSelection;


	/**
	 * Constructor
	 */
    public ContinueCharacterGUI(Renderer renderer) {
    	this.renderer = renderer;
    	//background = (new ImageIcon("Images/continueCharacterScreen.gif")).getImage();
    	currentSelection = 0;
    }


    /**
     * mouseMoved
     * @param mouseEvent The event the mouse goes through.
     */
    public void mouseMoved(MouseEvent mouseEvent) {
        if (mouseEvent.getX() > 250 && mouseEvent.getX() < 675) {
            if (mouseEvent.getY() >= 240 && mouseEvent.getY() <= 260) {
            	currentSelection = 0;
            }
        }
    }


    /**
     * mouseReleased
     * @param mouseEvent The event the mouse goes through.
     */
    public void mouseReleased(MouseEvent mouseEvent) {
        if (mouseEvent.getX() > 250 && mouseEvent.getX() < 675) {
            if (mouseEvent.getY() >= 240 && mouseEvent.getY() <= 260) {
            	renderer.switchWindow(Renderer.CHARACTER_CREATION_WINDOW);
            } else if (mouseEvent.getY() >= 360 && mouseEvent.getY() <= 380) {
            	// TODO
            	renderer.switchWindow(Renderer.WORLD_WINDOW);
            } else if (mouseEvent.getY() >= 480 && mouseEvent.getY() <= 500) {
            	renderer.setGameRunning(false);
            }
        }
    }


    /**
     * keyPressed
     * @param keyEvent The key that gets pressed.
     */
    public void keyPressed(KeyEvent keyEvent) {
    	if (keyEvent.getKeyCode() == KeyEvent.VK_ESCAPE) {
			renderer.setGameRunning(false);
		}
    }


    /**
     * render
     * @param graphics The graphics display.
     */
    public void render(Graphics2D graphics) {
    	// draw the background
    	graphics.drawImage(background, 0, 0, null);

    	// draw the title
    	graphics.setFont(graphics.getFont().deriveFont(76.0f));
    	graphics.setColor(Color.CYAN);
    	graphics.drawString("MYSTIC REALMS", 140, 140);
    }
}