package graphics;


/**
 * Imports
 */
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.Toolkit;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.awt.image.BufferedImage;

import javax.swing.ImageIcon;
import javax.swing.JTable;
import javax.swing.table.JTableHeader;


/**
 * TitleGUI
 */
public class ItemMakerGUI extends GUI {
	/**
	 * Class Variables
	 */
	private Renderer renderer;
	private Image background;
	private BufferedImage tableImage;
	private JTable table;
	private JTableHeader tableHeader;


	/**
	 * Constructor
	 */
    public ItemMakerGUI(Renderer renderer) {
    	this.renderer = renderer;
    	renderer.setSize(384, 288);
        int screenWidth = Toolkit.getDefaultToolkit().getScreenSize().width;
        int screenHeight = Toolkit.getDefaultToolkit().getScreenSize().height;
        renderer.setLocation((screenWidth - 384) / 2, (screenHeight - 288) / 2);
    	background = (new ImageIcon("Images/GameEngine/Background.gif")).getImage();

    	// need a drop-down for profession-specific items?
    	// setup the table
    	/*Object[][] data = {
    		{"tempname", "temploc", new Integer(0), new Integer(0), new Integer(2), "none", "none"}
    	};
    	String[] columns = {"NAME", "LOCATION", "DAMAGE", "ATTACK SPEED", "ARMOR", "CLICKABLE SPELL", "SPELL EFFECT"};
    	table = new JTable(data, columns);
    	tableHeader = table.getTableHeader();
    	tableImage = new BufferedImage(tableHeader.getWidth() + table.getWidth(),
    								   tableHeader.getHeight() + table.getHeight(),
    								   BufferedImage.TYPE_INT_RGB);
    	Graphics2D graphics2D = (Graphics2D) tableImage.getGraphics();
    	tableHeader.paint(graphics2D);
    	graphics2D.translate(0, tableHeader.getHeight());
    	table.paint(graphics2D);*/
    }


    /**
     * mouseMoved
     * @param mouseEvent The event the mouse goes through.
     */
    public void mouseMoved(MouseEvent mouseEvent) {
    }


    /**
     * mouseDragged
     * @param mouseEvent The event the mouse goes through.
     */
    public void mouseDragged(MouseEvent mouseEvent) {
    }


    /**
     * mouseReleased
     * @param mouseEvent The event the mouse goes through.
     */
    public void mouseReleased(MouseEvent mouseEvent) {
    }


    /**
     * keyPressed
     * @param keyEvent The key that gets pressed.
     */
    public void keyPressed(KeyEvent keyEvent) {
    	// exiting item maker
    	if (keyEvent.getKeyCode() == KeyEvent.VK_ESCAPE) {
    		renderer.switchWindow(Renderer.ENGINE_TITLE_WINDOW);
    	}
    }


    /**
     * render
     * @param graphics The graphics display.
     */
    public void render(Graphics2D graphics) {
    	// draw the background
    	graphics.drawImage(background, 0, 0, null);

    	// list all of the current items
    	graphics.drawImage(tableImage, null, 10, 10);
    }
}